@import CoreFoundation;
@import Foundation;

#include <dlfcn.h>

void* getOriginalLibrary()
{
	return dlopen("/System/Library/PrivateFrameworks/SkyLight.framework/Versions/A/SkyLightOriginal",RTLD_LAZY);
}

// logind
// copied from new SkyLight
NSString* kSLSSessionSwitchTransitionTypeCube=@"cube";
NSString* kSLSSessionSwitchTransitionTypeKey=@"transition";
NSString* kSLSSessionSwitchTransitionTypeNone=@"none";
NSString* kSLSSessionSwitchTransitionTypeUnset=@"";

void SLSSessionSwitchToAuditSessionIDWithOptions(int64_t sessionID,NSDictionary* transitionStuff)
{
	void (*setCubeFunction)(bool)=(void (*)(bool))dlsym(getOriginalLibrary(),"SLSSetSessionSwitchCubeAnimation");
	setCubeFunction([[transitionStuff objectForKey:kSLSSessionSwitchTransitionTypeKey] isEqual:kSLSSessionSwitchTransitionTypeCube]);
	
	void (*sessionSwitchFunction)(int64_t)=sessionSwitchFunction=(void (*)(int64_t))dlsym(getOriginalLibrary(),"SLSSessionSwitchToAuditSessionID");
	sessionSwitchFunction(sessionID);
}

// AppKit
int kSLSScreenTimeSuppressAnimationDurationKey=0;
int kSLSScreenTimeSuppressStateKey=0;

// HIServices, Dock
void SLSGetDockRectWithOrientation(int64_t connection,CGRect rect,int64_t reason,int64_t orientation)
{
	void (*getRectFunction)(int64_t,CGRect,int64_t)=(void (*)(int64_t,CGRect,int64_t))dlsym(getOriginalLibrary(),"SLSGetDockRectWithReason");
	
	getRectFunction(connection,rect,reason);
}
void SLSSetDockRectWithOrientation(int64_t connection,CGRect rect,int64_t reason,int64_t orientation)
{
	void (*setRectFunction)(int64_t,CGRect,int64_t)=(void (*)(int64_t,CGRect,int64_t))dlsym(getOriginalLibrary(),"SLSSetDockRectWithReason");
	
	setRectFunction(connection,rect,reason);
}

// message printed by System Preferences
int SLSIsSuppressedByScreenTime(int a)
{
	return 0;
}

// General prefpane
int SLSGetAppearanceThemeSwitchesAutomatically(int a)
{
	return 0;
}
int SLSSetAppearanceThemeSwitchesAutomatically(int a)
{
	return 0;
}

// loginwindow, mdworker (first boot)
int SLSHWCaptureProcessWindowsInSpaceIncludeDesktop(int a)
{
	return 0;
}

// PowerlogLiteOperators
CFStringRef kSLDataTimelineInfoOptionPerProcessWindows=CFSTR("");
CFStringRef kSLDataTimelineReportIntervalSnapshotCountKey=CFSTR("");
CFStringRef kSLDataTimelineReportIntervalTimeInSecondsKey=CFSTR("");
CFStringRef kSLDataTimelineReportIntervalReportInKiBKey=CFSTR("");
CFStringRef kSLDataTimelineSampleIntervalSnapshotCountKey=CFSTR("");
CFStringRef kSLDataTimelineSampleIntervalTimeInSecondsKey=CFSTR("");

// UniversalAccessCore
int SLSSetZoomDisplay(int a)
{
	return 0;
}

// from nm -gU diff
int SLSAAHSetAppearanceTheme(int a)
{
	return 0;
}
int SLSCopyAllSessionPropertiesTemporaryBridge(int a)
{
	return 0;
}
int SLSCopySessionPropertiesTemporaryBridge(int a)
{
	return 0;
}
int SLSDisplayStreamSidecarTouchBar(int a)
{
	return 0;
}
int SLSFindSessionAuditSessionID(int a)
{
	return 0;
}
int SLSGetWindowLayerContext(int a)
{
	return 0;
}
int SLSGetZoomDisplay(int a)
{
	return 0;
}
int SLSHWCaptureStreamCreateWithWindow(int a)
{
	return 0;
}
int SLSIsAccessibilityDisplay(int a)
{
	return 0;
}
int SLSIsZoomDisplay(int a)
{
	return 0;
}
int SLSMoveSessionToConsoleTemporaryBridge(int a)
{
	return 0;
}
int SLSReleaseSessionTemporaryBridge(int a)
{
	return 0;
}
int SLSRequestListenEventAccess(int a)
{
	return 0;
}
int SLSRequestPostEventAccess(int a)
{
	return 0;
}
int SLSRequestScreenCaptureAccess(int a)
{
	return 0;
}
int SLSScreenTimeSuppressWindows(int a)
{
	return 0;
}
int SLSSetSessionPropertiesTemporaryBridge(int a)
{
	return 0;
}
int SLSToggleDisplayZoom(int a)
{
	return 0;
}
int SLSessionOwnerCreateWithPort(int a)
{
	return 0;
}
int kSLDisplayStreamGPUBoost=0;
int kSLSDisplayConfigurationTimeline=0;
int kSLSDisplayFadeTimeline=0;
int kSLSDisplayUUIDCallbackTimeline=0;
int kSLSMenuBarHasHiddenUserspaceBarKey=0;
int kSLSScreenTimeAllowDuringLockoutKey=0;
int kSLSScreenTimeSuppressPIDKey=0;
int kSLSScreenTimeSuppressPolicyKey=0;
int kSLSSpaceAbsoluteLevelShieldWindow=0;
